function board = frontierBoard(n)
% This function will create a field with movement costs and walls, a start
% and goal position at random, a matrix in which the algorithm will store 
% f values, and a cell matrix in which it will store pointers


    % Board size
    board.n = n;

    % Create start position and goal position
    board.start.y = floor(n/2);
    board.start.x = floor(n/3);
    board.goal.y  = floor(n/2);
    board.goal.x  = n-1;
    
    % create the board and place walls with infinite cost...
    board.cost = ones(n,n);
    % force movement cost at start and goal positions to not be walls
    board.cost(board.start.x, board.start.y) = 0; 
  
    % put not a numbers (NaN) in cost chart so A* knows where to look 
    board.costchart = NaN*ones(n,n);
    % set the cost at the starting position to be 0
    board.costchart(board.start.x, board.start.y) = 0;
