function board = pacmanBoard(n)
% This function will create a field with movement costs and walls, a start
% and goal position at random, a matrix in which the algorithm will store 
% f values, and a cell matrix in which it will store pointers

    board.n = n;
    
    % Create start and goal positions
    board.start.x = floor(n/2);
    board.start.y = floor(n/2);
    board.goal(1).x  = 2;
    board.goal(1).y  = 2;
    board.goal(2).x  = 2;
    board.goal(2).y  = n-1;
    board.goal(3).x  = n-1;
    board.goal(3).y  = 2;
    board.goal(4).x  = n-1;
    board.goal(4).y  = n-1;
    
    % create the board and place walls with infinite cost
    board.cost = ones(n,n);
    
    board.cost(4,4:8) = Inf;
    board.cost(4:8,4) = Inf;

    board.cost(4,n-7:n-3) = Inf;
    board.cost(4:8,n-3) = Inf;

    board.cost(n-3,4:8) = Inf;
    board.cost(n-7:n-3,4) = Inf;

    board.cost(n-3,n-7:n-3) = Inf;
    board.cost(n-7:n-3,n-3) = Inf;

    board.cost(8,8:n-7) = Inf;
    board.cost(n-7,8:n-7) = Inf;
    board.cost(8:n-7,8) = Inf;

    % force movement cost at start and goal positions to not be walls
    board.cost(board.start.x, board.start.y) = 0; 

    % put not a numbers (NaN) in cost chart so A* knows where to look 
    board.costchart = NaN*ones(n,n);
    % set the cost at the starting position to be 0
    board.costchart(board.start.x, board.start.y) = 0;
