function board = randomBoard(n,wallpercent)
% This function will create a field with movement costs and walls, a start
% and goal position at random, a matrix in which the algorithm will store 
% f values, and a cell matrix in which it will store pointers

    board.n = n;

    % create start position and goal position
    board.start.x = ceil(n.*rand); % 2;
    board.start.y = ceil(n.*rand); % 2;
    board.goal.x  = ceil(n.*rand); % n-1;
    board.goal.y  = ceil(n.*rand); % n-1;

    % create the board and place walls with infinite cost
    board.cost = ones(n,n); % + 10*rand(n,n);
    board.cost(ind2sub([n n],ceil(n^2.*rand(floor(n*n*wallpercent),1)))) = Inf;
    
    % force movement cost at start and goal positions to not be walls
    board.cost(board.start.x, board.start.y) = 0; 

    % put not a numbers (NaN) in cost chart so A* knows where to look 
    board.costchart = NaN*ones(n,n);
    % set the cost at the starting position to be 0
    board.costchart(board.start.x, board.start.y) = 0;
