function puntos = test ()

puntos = 0;

% 10% Estados del problema

puntos = puntos + 2.0*testInitialState();
puntos = puntos + 2.0*testSameState();
puntos = puntos + 2.0*testFinalState();
puntos = puntos + 4.0*testNextState();

% 20% Funciones heursticas

puntos = puntos + 1.0*testHeuristic('pacman20', 'ucs',        pacmanBoard(20), 0);
puntos = puntos + 1.0*testHeuristic('pacman20', 'euclidean',  pacmanBoard(20), sqrt(17*17*2));
puntos = puntos + 1.0*testHeuristic('pacman20', 'manhattan',  pacmanBoard(20), 34);
puntos = puntos + 1.0*testHeuristic('pacman20', 'chessboard', pacmanBoard(20), 17);
puntos = puntos + 1.0*testHeuristic('pacman20', 'euclidean2', pacmanBoard(20), 17*17*2); % No admisible

puntos = puntos + 1.0*testHeuristic('pacman10', 'ucs',        pacmanBoard(10), 0);
puntos = puntos + 1.0*testHeuristic('pacman10', 'euclidean',  pacmanBoard(10), sqrt(7*7*2));
puntos = puntos + 1.0*testHeuristic('pacman10', 'manhattan',  pacmanBoard(10), 14);
puntos = puntos + 1.0*testHeuristic('pacman10', 'chessboard', pacmanBoard(10), 7);
puntos = puntos + 1.0*testHeuristic('pacman10', 'euclidean2', pacmanBoard(10), 7*7*2);

puntos = puntos + 1.0*testHeuristic('frontier15', 'ucs',        frontierBoard(15), 0);
puntos = puntos + 1.0*testHeuristic('frontier15', 'euclidean',  frontierBoard(15), 9);
puntos = puntos + 1.0*testHeuristic('frontier15', 'manhattan',  frontierBoard(15), 9);
puntos = puntos + 1.0*testHeuristic('frontier15', 'chessboard', frontierBoard(15), 9);
puntos = puntos + 1.0*testHeuristic('frontier15', 'euclidean2', frontierBoard(15), 81);

puntos = puntos + 1.0*testHeuristic('cost15', 'ucs',        costBoard(15), 0);
puntos = puntos + 1.0*testHeuristic('cost15', 'euclidean',  costBoard(15), sqrt(288));
puntos = puntos + 1.0*testHeuristic('cost15', 'manhattan',  costBoard(15), 24);
puntos = puntos + 1.0*testHeuristic('cost15', 'chessboard', costBoard(15), 12);
puntos = puntos + 1.0*testHeuristic('cost15', 'euclidean2', costBoard(15), 288);

% 50% Algoritmos de bsqueda

set(0,'DefaultFigureVisible','off'); 

disp('[DFS] Bsqueda en profundidad...');
puntos = puntos + 5.0*testDFS(pacmanBoard(20), [180 307]);
disp('[BFS] Bsqueda en anchura...');
puntos = puntos + 5.0*testBFS(pacmanBoard(20), [34 343]);

disp('[UCS] Bsqueda de coste uniforme...');
%puntos = puntos + 2.0*testUCS(pacmanBoard(20), [34 343]);
puntos = puntos + 2.0*testUCS(pacmanBoard(18), [30 273]);
puntos = puntos + 2.0*testUCS(pacmanBoard(16), [26 151]);
puntos = puntos + 2.0*testUCS(costBoard(15), [26 128]);
puntos = puntos + 2.0*testUCS(costBoard(10), [16 64]);
puntos = puntos + 2.0*testUCS(costBoard(5),  [4 18]);

disp('[A*] Algoritmo A*...');

%puntos = puntos + 5.0*testAStar('pacman20', 'euclidean',  pacmanBoard(20), [34 290]);
%puntos = puntos + 5.0*testAStar('pacman20', 'manhattan',  pacmanBoard(20), [34 236]);
%puntos = puntos + 5.0*testAStar('pacman20', 'chessboard', pacmanBoard(20), [34 300]);
%puntos = puntos + 5.0*testAStar('pacman20', 'euclidean2', pacmanBoard(20), [36 49]); % Inadmisible

puntos = puntos + 1.0*testAStar('pacman18', 'euclidean',  pacmanBoard(18), [30 233]);
puntos = puntos + 1.0*testAStar('pacman18', 'manhattan',  pacmanBoard(18), [30 188]);
puntos = puntos + 1.0*testAStar('pacman18', 'chessboard', pacmanBoard(18), [30 238]);

puntos = puntos + 1.0*testAStar('pacman16', 'euclidean',  pacmanBoard(16), [26 118]);
puntos = puntos + 1.0*testAStar('pacman16', 'manhattan',  pacmanBoard(16), [26 95]);
puntos = puntos + 1.0*testAStar('pacman16', 'chessboard', pacmanBoard(16), [26 120]);

puntos = puntos + 1.0*testAStar('pacman10', 'euclidean',  pacmanBoard(10), [14 45]);
puntos = puntos + 1.0*testAStar('pacman10', 'manhattan',  pacmanBoard(10), [14 34]);
puntos = puntos + 1.0*testAStar('pacman10', 'chessboard', pacmanBoard(10), [14 47]);

puntos = puntos + 1.0*testAStar('zigzag10', 'euclidean', zigzagBoard(10), [18 64]);
puntos = puntos + 1.0*testAStar('zigzag10', 'manhattan', zigzagBoard(10), [18 62]);
puntos = puntos + 1.0*testAStar('zigzag10', 'chessboard', zigzagBoard(10), [18 66]);

puntos = puntos + 1.0*testAStar('impossible', 'euclidean',  impossibleBoard(10), [0 100]);
puntos = puntos + 1.0*testAStar('impossible', 'manhattan',  impossibleBoard(10), [0 100]);
puntos = puntos + 1.0*testAStar('impossible', 'chessboard', impossibleBoard(10), [0 100]);

puntos = puntos + 1.0*testAStar('clear10', 'euclidean',  clearBoard(10), [14 74]);
puntos = puntos + 1.0*testAStar('clear10', 'manhattan',  clearBoard(10), [14 63]);
puntos = puntos + 1.0*testAStar('clear10', 'chessboard', clearBoard(10), [14 76]);

puntos = puntos + 1.0*testAStar('frontier15', 'euclidean',  frontierBoard(15), [9 9]);
puntos = puntos + 1.0*testAStar('frontier15', 'manhattan',  frontierBoard(15), [9 9]);
puntos = puntos + 1.0*testAStar('frontier15', 'chessboard', frontierBoard(15), [9 9]);

puntos = puntos + 1.0*testAStar('cost15', 'euclidean',  costBoard(15), [26 103]);
puntos = puntos + 1.0*testAStar('cost15', 'manhattan',  costBoard(15), [26 98]);
puntos = puntos + 1.0*testAStar('cost15', 'chessboard', costBoard(15), [26 107]);

puntos = puntos + 1.0*testAStar('cost10', 'euclidean',  costBoard(10), [16 53]);
puntos = puntos + 1.0*testAStar('cost10', 'manhattan',  costBoard(10), [16 51]);
puntos = puntos + 1.0*testAStar('cost10', 'chessboard', costBoard(10), [16 57]);

puntos = puntos + 1.0*testAStar('cost5', 'euclidean', costBoard(5),  [4 10]);
puntos = puntos + 1.0*testAStar('cost5', 'manhattan', costBoard(5),  [4 8]);
puntos = puntos + 1.0*testAStar('cost5', 'chessboard', costBoard(5), [4 11]);

cd multi;


% 20% objetivos mltiples

disp('[Mltiples objetivos] Algoritmo A*...');

puntos = puntos + 5.0*testAStar('clear5', 'euclidean',  multiClearBoard(5), [8 61]);
puntos = puntos + 5.0*testAStar('clear5', 'manhattan',  multiClearBoard(5), [8 51]);
puntos = puntos + 5.0*testAStar('clear5', 'chessboard', multiClearBoard(5), [8 95]);
puntos = puntos + 5.0*testAStar('impossible10', 'manhattan',  multiImpossibleBoard(10), [0 100]);

cd ..;

set(0,'DefaultFigureVisible','on'); 

total = 100;

% Respuestas a los ejercicios

try 
  resultados;
catch
  disp(['AVISO: Existe un problema en su fichero de respuestas a los ejercicios. Por favor, revise posibles errores...']);  
end

disp ([ 'Puntuacin total = ', num2str(100*(puntos/total)), '%'] );

%%%%%%

function vector = boards ()

vector(1) = clearBoard(20);
vector(2) = frontierBoard(20);
vector(3) = costBoard(20);
vector(4) = zigzagBoard(20);
vector(5) = pacmanBoard(20);
vector(6) = impossibleBoard(20);

load randomBoard;
vector(7) = board;

%%%%%%

function [pct ok total] = testInitialState ()

total = 0;
ok = 0;

problemas = boards();

for i=1:length(problemas)

board = problemas(i);

try 
  total = total + 1;
  state = initialState(board);
  ok = ok + 1;
catch
  disp(['[initialState] Error: No fue posible ejecutar la funcin initialState()']);  
end

try 
  total = total + 1;
  if (state.x == board.start.x)
     ok = ok + 1;
  else
     disp(['[initialState] Error: La coordenada X del estado inicial debera ser ', num2str(board.goal.x)]);
  end
catch
  disp(['[initialState] Error: No fue posible acceder a la coordenada X del estado inicial.']);  
end

try 
  total = total + 1;
  if (state.y == board.start.y)
     ok = ok + 1;
  else
     disp(['[initialState] Error: La coordenada Y del estado inicial debera ser ', num2str(board.goal.y)]);
  end
catch
  disp(['[initialState] Error: No fue posible acceder a la coordenada Y del estado inicial.']);  
end

try 
  total = total + 1;
  if (state.cost == 0)
     ok = ok + 1;
  else
     disp('[initialState] Error: El coste del estado inicial debera ser cero.');
  end
catch
  disp(['[initialState] Error: No fue posible acceder al coste del estado inicial.']);  
end

try 
  total = total + 1;
  if (state.prev == 0)
     ok = ok + 1;
  else
     disp('[initialState] Error: El estado inicial no proviene de ningn otro estado.');
  end
catch
  disp(['[initialState] Error: No fue posible acceder al miembro que indica que el estado inicial es realmente el inicial.']);  
end

end

disp(['Tests completados: ', num2str(ok), '/', num2str(total), ' @ initialState']);
pct = ok / total;


%%%%%%

function [pct ok total] = testSameState ()

total = 0;
ok = 0;

problemas = boards();
board = problemas(1);

try 
  total = total + 2;
  state = initialState(board);
  
  if sameState(state,state)
     ok = ok + 1;
  else
     disp('[sameState] Error: Un estado es siempre igual a s mismo.');
  end

  ok = ok + 1;
catch
  disp(['[sameState] Error: No fue posible ejecutar la funcin sameState()']);  
end

try 
  total = total + 1;
  state1 = initialState(board);
  state2 = initialState(board);
  state2.x = state2.x + 1;

  if ~sameState(state1,state2)
     ok = ok + 1;
  else
     disp('[sameState] Error: Dos estados son diferentes si difieren sus coordenadas X.');
  end
catch
  disp(['[sameState] Error: No fue posible ejecutar la funcin sameState()']);  
end

try 
  total = total + 1;
  state1 = initialState(board);
  state2 = initialState(board);
  state2.y = state2.y + 1;

  if ~sameState(state1,state2)
     ok = ok + 1;
  else
     disp('[sameState] Error: Dos estados son diferentes si difieren sus coordenadas Y.');
  end
catch
  disp(['[sameState] Error: No fue posible ejecutar la funcin sameState()']);  
end

try 
  total = total + 1;
  state1 = initialState(board);
  state2 = initialState(board);
  state2.prev = state2.prev + 1;
  state2.cost = state2.cost + 1;

  if sameState(state1,state2)
     ok = ok + 1;
  else
     disp('[sameState] Error: Dos estados son iguales si coinciden sus coordenadas.');
  end
catch
  disp(['[sameState] Error: No fue posible ejecutar la funcin sameState()']);  
end


disp(['Tests completados: ', num2str(ok), '/', num2str(total), ' @ sameState']);

pct = ok / total;


%%%%%%

function [pct ok total] = testFinalState ()

total = 0;
ok = 0;

problemas = boards();
problemas = boards();

for i=1:length(problemas)

board = problemas(i);

try 
  total = total + 1;
  state = initialState(board);
  
  if ~finalState(board,state)
     ok = ok + 1;
  else
     disp('[finalState] Error: El estado inicial no es un estado final del problema.');
  end

catch
  disp(['[finalState] Error: No fue posible ejecutar la funcin finalState()']);  
end

try 
  total = total + 1;
  state = initialState(board);
  state.x = board.goal.x;
  state.y = board.goal.y;

  if finalState(board,state)
     ok = ok + 1;
  else
     disp('[finalState] Error: El estado final del problema no fue identificado como tal.');
  end

catch
  disp(['[finalState] Error: No fue posible ejecutar la funcin finalState()']);  
end

end

disp(['Tests completados: ', num2str(ok), '/', num2str(total), ' @ finalState']);

pct = ok / total;

%%%%%%

function [pct ok total] = testNextState ()

total = 0;
ok = 0;

board = clearBoard(5);

try 
  total = total + 12;
  state = initialState(board);
  
  state.x = 2;
  state.y = 2;

  new = nextState(board,state,'R');
  
  if (new.x==3 & new.y==2)
     ok = ok + 1;
  else
     disp(['[nextState] Error al moverse a la derecha desde (',num2str(state.x),',',num2str(state.y),') en un tablero de ',board.n,'x',board.n,'.']);
  end

  new = nextState(board,state,'L');

  if (new.x==1 & new.y==2)
     ok = ok + 1;
  else
     disp(['[nextState] Error al moverse a la izquierda desde (',num2str(state.x),',',num2str(state.y),') en un tablero de ',board.n,'x',board.n,'.']);
  end
  
  new = nextState(board,state,'D');
  
  if (new.x==2 & new.y==1)
     ok = ok + 1;
  else
     disp(['[nextState] Error al moverse hacia abajo desde (',num2str(state.x),',',num2str(state.y),') en un tablero de ',board.n,'x',board.n,'.']);
  end

  new = nextState(board,state,'U');
  
  if (new.x==2 & new.y==3)
     ok = ok + 1;
  else
     disp(['[nextState] Error al moverse hacia abajo desde (',num2str(state.x),',',num2str(state.y),') en un tablero de ',board.n,'x',board.n,'.']);
  end

  state.x = 1;
  state.y = 1;

  new = nextState(board,state,'R');
  
  if (new.x==2 & new.y==1)
     ok = ok + 1;
  else
     disp(['[nextState] Error al moverse a la derecha desde (',num2str(state.x),',',num2str(state.y),') en un tablero de ',board.n,'x',board.n,'.']);
  end

  new = nextState(board,state,'L');

  if (new.x==1 & new.y==1)
     ok = ok + 1;
  else
     disp(['[nextState] Error al moverse a la izquierda desde (',num2str(state.x),',',num2str(state.y),') en un tablero de ',board.n,'x',board.n,'.']);
  end
  
  new = nextState(board,state,'D');
  
  if (new.x==1 & new.y==1)
     ok = ok + 1;
  else
     disp(['[nextState] Error al moverse hacia abajo desde (',num2str(state.x),',',num2str(state.y),') en un tablero de ',board.n,'x',board.n,'.']);
  end

  new = nextState(board,state,'U');
  
  if (new.x==1 & new.y==2)
     ok = ok + 1;
  else
     disp(['[nextState] Error al moverse hacia abajo desde (',num2str(state.x),',',num2str(state.y),') en un tablero de ',board.n,'x',board.n,'.']);
  end

  state.x = board.n;
  state.y = board.n;

  new = nextState(board,state,'R');
  
  if (new.x==board.n & new.y==board.n)
     ok = ok + 1;
  else
     disp(['[nextState] Error al moverse a la derecha desde (',num2str(state.x),',',num2str(state.y),') en un tablero de ',board.n,'x',board.n,'.']);
  end

  new = nextState(board,state,'L');

  if (new.x==board.n-1 & new.y==board.n)
     ok = ok + 1;
  else
     disp(['[nextState] Error al moverse a la izquierda desde (',num2str(state.x),',',num2str(state.y),') en un tablero de ',board.n,'x',board.n,'.']);
  end
  
  new = nextState(board,state,'D');
  
  if (new.x==board.n & new.y==board.n-1)
     ok = ok + 1;
  else
     disp(['[nextState] Error al moverse hacia abajo desde (',num2str(state.x),',',num2str(state.y),') en un tablero de ',board.n,'x',board.n,'.']);
  end

  new = nextState(board,state,'U');
  
  if (new.x==board.n & new.y==board.n)
     ok = ok + 1;
  else
     disp(['[nextState] Error al moverse hacia abajo desde (',num2str(state.x),',',num2str(state.y),') en un tablero de ',board.n,'x',board.n,'.']);
  end

catch
  disp(['[nextState] Error: No fue posible ejecutar la funcin nextState()']);  
end

disp(['Tests completados: ', num2str(ok), '/', num2str(total), ' @ nextState']);

pct = ok / total;



%%%%%%

function [pct ok total] = testHeuristic (testsuite, method, board, key)

total = 0;
ok = 0;

try 
  total = total + 1;
  state = initialState(board);
  h = heuristic(method,board,state);
  
  if (abs(h-key)<0.0001)
     ok = ok + 1;
  else
     disp(['[heuristic @ ',testsuite,'] Error: Valor heurstico ', num2str(h),' incorrecto para la heurstica ''',method,''' (debera ser ',num2str(key),'.']);  
  end

catch
  disp(['[heuristic] Error: No fue posible ejecutar la funcin heuristic()']);  
end


disp(['Tests completados: ', num2str(ok), '/', num2str(total), ' @ heuristic ''', method, '''']);

pct = ok / total;

%%%%%%

function [pct ok total]  = testDFS (board, key)

total = 0;
ok = 0;

try 
  total = total + 3;
  [solucion, nodos] = dfs(board);
  ok = ok + 1;

  if (length(solucion)-1 == key(1))
     ok = ok + 1;
  else
     disp('- Solucin incorrecta.');
  end

  if (nodos == key(2))
     ok = ok + 1;
  else
     disp('- Nmero incorrecto de nodos expandidos.');
  end

catch
  disp(['[DFS] Error: No fue posible ejecutar la funcin dfs()']);  
end


disp(['Tests completados: ', num2str(ok), '/', num2str(total), ' @ DFS']);

pct = ok / total;

%%%%%%

function [pct ok total] = testBFS (board, key)

total = 0;
ok = 0;

try 
  total = total + 3;
  [solucion, nodos] = bfs(board);
  ok = ok + 1;
  if (length(solucion)-1 == key(1))
     ok = ok + 1;
  else
     disp('- Solucin incorrecta.');
  end

  if (nodos == key(2))
     ok = ok + 1;
  else
     disp('- Nmero incorrecto de nodos expandidos.');
  end
catch
  disp(['[BFS] Error: No fue posible ejecutar la funcin bfs()']);  
end


disp(['Tests completados: ', num2str(ok), '/', num2str(total), ' @ BFS']);

pct = ok / total;

%%%%%%

function [pct ok total] = testUCS (board, key)

total = 0;
ok = 0;

try 
  total = total + 3;
  [solucion, nodos] = ucs(board);
  ok = ok + 1;
  if (length(solucion)-1 == key(1))
     ok = ok + 1;
  else
     disp('- Solucin incorrecta.');
  end

  if (nodos == key(2))
     ok = ok + 1;
  else
     disp('- Nmero incorrecto de nodos expandidos.');
  end
catch
  disp(['[UCS] Error: No fue posible ejecutar la funcin ucs()']);  
end


disp(['Tests completados: ', num2str(ok), '/', num2str(total), ' @ UCS']);

pct = ok / total;

%%%%%%

function [pct ok total] = testAStar (testsuite, method, board, key)

total = 0;
ok = 0;

try 

  disp(['[', testsuite, '] A* ',method]);

  total = total + 4;
  [solucion, nodos] = astar(board,method);

  ok = ok + 1;
  
  if (key(1)==0 & length(solucion)==0) | (length(solucion)-1 == key(1))
     ok = ok + 1;
  elseif (length(solucion)-1 > key(1))
     disp('- Solucin subptima.');
  else
     disp('- Solucin incorrecta.');
  end

  if (nodos == key(2))
     ok = ok + 1;
  else
     disp('- Nmero incorrecto de nodos expandidos.');
  end

  h = heuristic(method,board, initialState(board));

  if (key(1)==0) | (h<=key(1))
     ok = ok + 1;
  else
     disp('- Heurstica inadmisible.');
  end;

catch
  disp(['[A*] Error: No fue posible ejecutar la funcin astar()']);  
end


disp(['Tests completados: ', num2str(ok), '/', num2str(total), ' @ A* ''', method, '''']);

pct = ok / total;
